.686p                     ; create 32 bit code
.model flat, stdcall      ; 32 bit memory model
option casemap :none      ; case sensitive
.xmm

include    \masm32\include\windows.inc
include    \masm32\include\user32.inc
include    \masm32\include\kernel32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib

.data
   a         dd 2048  dup (0)  ; initially f0, f1 -> a, b
   b         dd 2048  dup (0)  ; later     f2, f3, f4, f5 -> a, b, a, b

   carry     dd 0
   max       dd 0
   eaz       dd 0
   ebz       dd 0

   fib       dd 0
   fibmax    dd 82749   ; stop at the 2749  541  47  kth fibonacci number
   arrmax    dd 2047    ; each spot in the two arrays a,b holds 9 digits, ie base 1 000 000 000
   junk      dd 0

   bothends  dd 0
   last9     dd 0   
   first9    dd 0
   junk2     dd 0

   szTitle   db "Calculated to the kth fibonacci number where k = "
   szFibk    db 256  dup (0)

   szLast9   db "The last 9 digits of the kth fibonacci number are "
   szAns     db 20480 dup (0)

; 


.code

align 4

dwtoa proc dwValue:DWORD, lpBuffer:DWORD

    ; -------------------------------------------------------------
    ; convert DWORD to ascii string
    ; dwValue is value to be converted
    ; lpBuffer is the address of the receiving buffer
    ; EXAMPLE:
    ; invoke dwtoa,edx,ADDR buffer
    ;
    ; Uses: eax, ecx, edx.
    ; -------------------------------------------------------------

    push ebx
    push esi
    push edi

    mov eax, dwValue
    mov edi, [lpBuffer]

    test eax,eax
    jnz sign

  zero:
    mov word ptr [edi],30h
    jmp dtaexit

  sign:
    jns pos
    mov byte ptr [edi],'-'
    neg eax
    add edi, 1

  pos:
    mov ecx, 3435973837
    mov esi, edi

    .while (eax > 0)
      mov ebx,eax
      mul ecx
      shr edx, 3
      mov eax,edx
      lea edx,[edx*4+edx]
      add edx,edx
      sub ebx,edx
      add bl,'0'
      mov [edi],bl
      add edi, 1
    .endw

    mov byte ptr [edi], 0       ; terminate the string

    ; We now have all the digits, but in reverse order.

    .while (esi < edi)
      sub edi, 1
      mov al, [esi]
      mov ah, [edi]
      mov [edi], al
      mov [esi], ah
      add esi, 1
    .endw

  dtaexit:

    pop edi
    pop esi
    pop ebx

    ret

dwtoa endp

; 












start:
   mov a, 0               ; f0
   mov fib, 0

   mov b, 1               ; f1
   inc fib

   mov max, 0

   mov ebx, offset b
   mov ebz, ebx
   mov esi, 0
   mov eax, offset a
   mov eaz, eax
   mov edi, 0

   mov edx, max
   shl edx, 2

   .repeat
 ;      for i := 0 to max do
 ;        a[i] := a[i] + b[i]

   alp:
     mov ecx, [ebx + esi]
     add [eax + edi], ecx
     add esi, 4
     add edi, 4
     cmp esi, edx
     jbe alp

 ;      clc
 ;      for i := 0 to max do
 ;        adc a[i]
 ;        if a[i] > 999 999 999 then
 ;          a[i] := a[i] - 1 000 000 000
 ;          stc
 ;        endif;
 ;      endfor;
 ;      if c then
 ;        inc max
 ;        mov edx, max
 ;        shl edx, 2
 ;        a[max] := a[max] + 1
 ;      endif;

     mov edi, 0
     mov edx, max
     shl edx, 2     
     mov carry, 0
   nlp:
 ;      btr carry, 0              ;  if carry == 1 stc
 ;      adc [eax + edi], 0
     mov ecx, carry
     add [eax + edi], ecx
     mov carry, 0

     mov ecx, [eax + edi]       ;      cmp [eax + edi], 999999999
     cmp ecx, 999999999
     jbe skipsb
       sub ecx, 1000000000      ;        sub [eax + edi], 1000000000
       mov [eax + edi], ecx
       mov carry, 1
   skipsb:  
     add edi, 4
     cmp edi, edx
     jbe nlp

     cmp carry, 0
     je  skipmx
       inc max                 ; do  if carry == 1
       mov edi, max
       mov ecx, 1
       shl edi, 2
       mov edx, edi
       add [eax + edi], ecx    ;  a[max] := a[i] + 1
    skipmx:
     inc fib

     mov eaz, eax
     mov ebz, ebx

 ;      call checklast9     ; not written yet
 ;      call checkfirst9    ; not written yet

     mov edx, last9
     add edx, first9
     mov bothends, edx

     mov ecx, fibmax        ; check if reached maximum kth fib search bound
     .if fib >= ecx
        mov bothends, 2
     .endif

     mov ecx, max           ; check if reached maximum storage for holding a fibonacci number
     .if ecx >= arrmax
        mov bothends, 2
     .endif

     .if bothends < 2
        mov eax, eaz
        mov ebx, ebz

        mov edx, max
        shl edx, 2

        mov esi, 0
        mov edi, 0
        xchg eax, ebx
     .endif

   .until bothends == 2

   invoke dwtoa, fib, ADDR szFibk

   mov ecx, eaz
   mov ecx, [ecx]
   invoke dwtoa, ecx, ADDR szAns

   invoke MessageBox,NULL,ADDR szLast9,ADDR szTitle,MB_OK

   invoke  ExitProcess, 0

end start